#ifndef _WATCHDOG_BASE_H_
#define _WATCHDOG_BASE_H_

//#define PRREG(z) printf(#z" 0x%x\n",z)

/*
    Pure virtual class for watchdogs. Needs specialization
*/

/*-
 * Copyright (c) 2019 Waldemar Dworakowski,
 *
 * All Rights Reserved
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Complete source form of any/all derivative/s and it's components must be 
 *    provided without any cost.
 * 4. Any derivative must use same licence.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


class WatchDog_Base
{
    public:
        enum RestartCauses {UNKNOWN=1, RESET=2, WATCHDOG=3};
        WatchDog_Base(void);
        virtual void Start(uint32_t Time_ms)=0;
        virtual void Stop(void)=0;
        virtual void Kick(void)=0;
        virtual uint32_t RestartCounter(void)=0;
        virtual enum RestartCauses RestartCause(void)=0;
        virtual ~WatchDog_Base();
    protected:
        uint32_t DoomsDayTime;
    private:
};        

#endif
